/**
 **	File ......... BaseParser.h
 **	Published ....  2004-05-17
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _BASEPARSER_H
#define _BASEPARSER_H


#define C the_str[the_ptr]
#define C1 the_str[the_ptr + 1]
#define C2 the_str[the_ptr + 2]
#define Cx the_str[strlen(the_str) - 1]

enum {
	NUMBER = 256,
	WHITESPACE,
	IDENTIFIER,
	CPP, // #preprocessor directive
	COMMENT,
	STRING, // "..."
	CC, // ::
	CHAR, // '.'
	LTLT, // <<
	GTGT, // >>
	DPTR, // **
	LTEQ, // <=
	NEQ, // !=
	GTEQ, // >=
	EQ, // ==
	OR, // ||
	AND, // &&
	PP, // ++
	MM, // --
	POINTER, // ->
	Class,
	Namespace,
	Using,
	Template,
	Friend,
	Typedef,
	Virtual,
	Public,
	Protected,
	Private,
	Const,
	Struct,
	Enum
};


class BaseParser
{
	typedef std::map<std::string,int> stringint_m;

public:
	BaseParser();
	virtual ~BaseParser();

	virtual void preprocessor(std::string &val);
	virtual void error(const std::string &str);

protected:
	int ReadLine(FILE *fil);
	int GetToken(FILE *fil,std::string &val);
	int GetWord(const std::string &str);
	std::string GetFilename() { return m_filename; }
	int GetLine() { return m_line; }
	int GetPos() { return m_pos; }
	void EndToken(char);
	//
	int m_level; // { }
	int m_plevel; // ( )
	int m_glevel; // < >

private:
	stringint_m m_word;
	std::string m_filename;
	int m_line;
	int m_pos;
	char the_str[5000];
	int the_ptr;
};


#endif // _BASEPARSER_H
