/**
 **	File ......... SimpleParser.h
 **	Published ....  2004-05-17
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _SIMPLEPARSER_H
#define _SIMPLEPARSER_H

#include "BaseParser.h"
#include "BlackAdder.h"


class SimpleParser : public BaseParser
{
public:
	SimpleParser(const std::string& path,BlackAdder *);
	~SimpleParser();

	void Parser(FILE *fil,int& line,const std::string& name);

private:
	void error(const std::string& str);
	int ReadLine(FILE *fil,int& line);
	int GetToken(FILE *fil,int& line,std::string& val);
	void include_file(const std::string& );
	void preprocessor(std::string& ,int& line);
	void find_types(CLS *,string_v&,int = 0);
	//
	char the_str[5000];
	int the_ptr;
	int m_state;
	std::vector<std::string> m_vec;
	std::string m_currentfile;
	std::string m_path;
	int m_levelm;
	int m_line;
	std::string m_namespace;
	std::map<int,std::string> m_namesave;
	int m_current; // Class, Namespace etc
	std::vector<std::string> m_added;
	BlackAdder *m_pAdder;
	int m_plevelm;
	std::string m_stfile;
	int m_stline;
	bool m_extern;
};


#endif // _SIMPLEPARSER_H
